MostWanted = {
	Initialized = false,
	Timer = 0,
	IndicatorCount = 5,
	Labels = {},
	Visible = false,
	Achievement = "c7A72B75C98750FA4",
	Zone = "z1E81B494CFA05AD0",
	Pointer = "indicator_track_arrow_green.png.dds",
	Path = { { xProportional = 0, yProportional = 0 }, { xProportional = 1, yProportional = 0 }, { xProportional = 1, yProportional = 1 }, { xProportional = 0, yProportional = 1 }, { xProportional = 0, yProportional = 0 } }
}

local this = MostWanted

function this.OnInit ()
	if this.Initialized then return end

	if MostWantedUISettings == nil then MostWantedUISettings = {} end
	if MostWantedList == nil then MostWantedList = {} end

	if MostWantedUISettings.window == nil then 
		MostWantedUISettings.window = { x = 100, y = 100 }
	end

        this.Context = UI.CreateContext('Bounties')
	this.Frame = UI.CreateFrame('Frame','', this.Context)
	this.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", MostWantedUISettings.window.x, MostWantedUISettings.window.y)
	this.Frame:SetWidth(200)
	this.Frame:SetHeight(19 * this.IndicatorCount)
	this.Frame:SetVisible(this.Visible)

	this.AttachDragFrame(this.Frame, MostWantedUISettings.window, false, -20, -5)

	this.Counter = UI.CreateFrame('Text','', this.Frame)
	this.Counter:SetPoint("TOPCENTER", this.Frame, "TOPCENTER", 0, 0)

	for i = 1, this.IndicatorCount do
		this.Labels[i] = {
			frame = UI.CreateFrame('Frame', '', this.Frame),
			control = UI.CreateFrame('Frame', '', this.Frame),
		}
		this.Labels[i].name = UI.CreateFrame('Text', '', this.Labels[i].control)
		this.Labels[i].distance = UI.CreateFrame('Text', '', this.Labels[i].control)
		this.Labels[i].pointer = UI.CreateFrame('Canvas', '', this.Labels[i].control)

		this.Labels[i].frame:SetPoint("TOPLEFT", this.Frame, "TOPLEFT", 0, i * 19)
		this.Labels[i].frame:SetPoint("BOTTOMRIGHT", this.Frame, "TOPRIGHT", 0, i * 19 + 18)
		this.Labels[i].frame:SetBackgroundColor(0, 0, 0, 0.2)
		this.Labels[i].frame:SetLayer(0)
		this.Labels[i].control:SetLayer(1)
		this.Labels[i].name:SetPoint("CENTERLEFT", this.Labels[i].frame, "CENTERLEFT", 2, 0)
		this.Labels[i].pointer:SetPoint("CENTERRIGHT", this.Labels[i].frame, "CENTERRIGHT", -2, 0)
		this.Labels[i].pointer:SetWidth(16)
		this.Labels[i].pointer:SetHeight(16)
		this.Labels[i].distance:SetPoint("CENTERRIGHT", this.Labels[i].frame, "CENTERRIGHT", -18, 0)
		this.Labels[i].distance:SetFontColor(1, 1, .8)
	end

	this.Initialized = true

	Command.Event.Attach(Event.System.Update.End, this.OnTimer, "Event.System.Update.End - Bounties.OnTimer")
end

function this.OnTimer ()
	if Inspect.System.Watchdog() < 0.1 then return end
	if Inspect.Time.Real() - this.Timer < .2 then return end

	this.Timer = Inspect.Time.Real()

	if this.List == nil then
		local det = (Inspect.Achievement.Detail(this.Achievement) or {}).requirement
		if det == nil then return end
		this.List = {}
		for k, v in pairs(det) do this.List[v.name] = true end
	end

	local player = Inspect.Unit.Detail("player") or {}
	local zone = player.zone == this.Zone
	if this.Visible ~= zone then this.Visible = zone this.Frame:SetVisible(this.Visible) end

	if zone then
		local time = math.floor((Inspect.Time.Server() - 14400) / 86400)
		local list = Inspect.Map.Detail(Inspect.Map.List()) or {}
		blist = {}

		local target = (Inspect.Unit.Detail("player.target") or {})
		if this.List[target.name] and target.guaranteedLoot then MostWantedList[target.name] = time end
        
		for k, v in pairs(list) do
			if (v.title or ""):find("This icon will only show when you have free loot rolls available for this colossus.") ~= nil then
				local dx, dy, dz = v.coordX - (player.coordX or 0), v.coordY - (player.coordY or 0), v.coordZ - (player.coordZ or 0)
				table.insert(blist, { 
					name = v.description:sub(1, v.description:find("\n") - 1), 
					distance = math.sqrt(dx * dx + dy * dy + dz * dz),
					angle = math.atan2(v.coordZ - (player.coordZ or 0), v.coordX - (player.coordX or 0));
				})
			end
		end

		for i = 1, this.IndicatorCount do
			this.Labels[i].control:SetVisible(blist[i] ~= nil)

			if blist[i] then
				local text = "<font color=\"#" .. iif(time > (MostWantedList[blist[i].name] or 0), "aaffaa", "ffaaaa") .. "\">" .. (blist[i].name or "") .. "</font>"
				local matrix = Utility.Matrix.Create(.5, .5, blist[i].angle + math.pi / 2, 8 * (1 + math.sin(blist[i].angle) + math.cos(blist[i].angle) / 2), 8 * (1 + math.sin(blist[i].angle) / 2 - math.cos(blist[i].angle)))

				this.Labels[i].name:SetText(text, true)
				this.Labels[i].distance:SetText(tostring(math.floor(blist[i].distance)))
				this.Labels[i].pointer:SetShape(this.Path, { type = "texture", source = "Rift", texture = this.Pointer, transform = matrix }, nil)
			end
		end

		local total, done = 0, 0
		for k, v in pairs(this.List) do
			total = total + 1
			if time <= (MostWantedList[k] or 0) then done = done + 1 end
		end
		this.Counter:SetText(tostring(done) .. " / " .. tostring(total))
	end
end

function this.AttachDragFrame (parent, variable, fLeft, borderWidth, borderHeight)
	local bindedFrame = parent

	local frame = UI.CreateFrame("Frame", "", bindedFrame)
	parent.DragFrame = frame
	frame:SetPoint("TOPLEFT", bindedFrame, "TOPLEFT", 0, 0)
	frame:SetPoint("BOTTOMRIGHT", bindedFrame, "BOTTOMRIGHT", 0, 0)

	frame:SetLayer(100)
	frame.parent = parent
	frame.MouseDown = false

	function frame.MouseButtonDown (fButton)
		if fButton == fLeft then
			frame.MouseDown = true
			local mouseData = Inspect.Mouse()
			frame.xDiff = frame.parent:GetLeft() - mouseData.x
			frame.yDiff = frame.parent:GetTop() - mouseData.y
		end
	end

	function frame.MouseButtonUp (fButton)
		if frame.Drag and fButton == fLeft then
			frame.Drag = false
		end
	end

	function frame.Event:LeftDown ()
		self.MouseButtonDown(true)
		if self.parent.Event.LeftDown then self.parent.Event.LeftDown() end
	end

	function frame.Event:RightDown ()
		self.MouseButtonDown(false)
		if self.parent.Event.RightDown then self.parent.Event.RightDown() end
	end
	
	function frame.Event:MouseMove (mouseX, mouseY)
		if self.MouseDown then
			self.Drag = true
			local x = math.min(math.max(mouseX + self.xDiff, -borderWidth), UIParent:GetWidth() - self.parent:GetWidth() + borderWidth)
			local y = math.min(math.max(mouseY + self.yDiff, -borderHeight), UIParent:GetHeight() - self.parent:GetHeight() + borderHeight)
			self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, y)

			variable.x = mouseX + self.xDiff
			variable.y = mouseY + self.yDiff
		end
		if self.parent.Event.MouseMove then self.parent.Event.MouseMove() end
	end

	function frame.Event:LeftUp ()
		self.MouseDown = false
		if self.parent.Event.LeftUp then self.parent.Event.LeftUp() end
		if (not self.Drag or not fLeft) and self.parent.Event.LeftClick then self.parent.Event.LeftClick() end
		self.MouseButtonUp(true)
	end

	function frame.Event:LeftUpoutside ()
		self.MouseDown = false
		if self.parent.Event.LeftUp then self.parent.Event.LeftUp() end
		self.MouseButtonUp(true)
	end

	function frame.Event:RightUp ()
		self.MouseDown = false
		if self.parent.Event.RightUp then self.parent.Event.RightUp() end
		if (not self.Drag or fLeft) and self.parent.Event.RightClick then self.parent.Event.RightClick() end
		self.MouseButtonUp(false)
	end

	function frame.Event:RightUpoutside ()
		self.MouseDown = false
		if self.parent.Event.RightUp then self.parent.Event.RightUp() end
		self.MouseButtonUp(false)
	end

	function frame.Event:MouseIn ()
		if self.parent.Event.MouseIn then self.parent.Event.MouseIn() end
	end

	function frame.Event:MouseOut ()
		if self.parent.Event.MouseOut then self.parent.Event.MouseOut() end
	end

	return frame
end

function iif (condition, trueExpression, falseExpression)
	if condition then  
		return trueExpression
	else  
		return falseExpression
	end  
end

Command.Event.Attach(Event.Addon.Startup.End, this.OnInit, "Event.Addon.Startup.End - MostWantedUISettings.OnInit")

